/***************************************************************************

  M.A.M.E.32  -  Multiple Arcade Machine Emulator for Win32
  Win32 Portions Copyright (C) 1997-2001 Michael Soderstrom and Chris Kirmse

  This file is part of MAME32, and may only be used, modified and
  distributed under the terms of the MAME license, in "readme.txt".
  By continuing to use, modify or distribute this file you indicate
  that you have read the license and understand and accept it fully.

 ***************************************************************************/

 /***************************************************************************

  m32imm.h

  Header file for Imput Method Manager.

***************************************************************************/

#ifndef MAME32IMM_H
#define MAME32IMM_H

DECLARE_HANDLE(HIMC);

HWND WINAPI ImmGetDefaultIMEWnd(HWND hWnd);
HIMC WINAPI ImmGetContext(HWND hWnd);
BOOL WINAPI ImmReleaseContext(HWND hWnd, HIMC hImc);
BOOL WINAPI ImmGetConversionStatus(HIMC hImc, LPDWORD lpdwConversion, LPDWORD lpdwSentence);
BOOL WINAPI ImmSetConversionStatus(HIMC hImc, DWORD dwConversion, DWORD dwSentence);
BOOL WINAPI ImmGetOpenStatus(HIMC hImc);
BOOL WINAPI ImmSetOpenStatus(HIMC hImc, BOOL bFlag);
#ifdef UNICODE
LONG WINAPI ImmGetCompositionStringW(HIMC hImc, DWORD dwIndex, LPVOID lpBuf, DWORD dwBufLen);
#define ImmGetCompositionString  ImmGetCompositionStringW
#else
LONG WINAPI ImmGetCompositionStringA(HIMC hImc, DWORD dwIndex, LPVOID lpBuf, DWORD dwBufLen);
#define ImmGetCompositionString  ImmGetCompositionStringA
#endif

BOOL WINAPI ImmIsIME(HKL hKeyboardlayout);
#ifdef UNICODE
UINT WINAPI ImmGetDescriptionW(HKL hKeyboardlayout, LPSTR szDescription, UINT uBufLen);
#define ImmGetDescription  ImmGetDescriptionW
#else
UINT WINAPI ImmGetDescriptionA(HKL hKeyboardlayout, LPSTR szDescription, UINT uBufLen);
#define ImmGetDescription  ImmGetDescriptionA
#endif // !UNICODE


#define IME_CMODE_ALPHANUMERIC          0x0000
#define IME_CMODE_NATIVE                0x0001
#define IME_CMODE_CHINESE               IME_CMODE_NATIVE
#define IME_CMODE_HANGEUL               IME_CMODE_NATIVE
#define IME_CMODE_HANGUL                IME_CMODE_NATIVE
#define IME_CMODE_JAPANESE              IME_CMODE_NATIVE
#define IME_CMODE_KATAKANA              0x0002  // only effect under IME_CMODE_NATIVE
#define IME_CMODE_LANGUAGE              0x0003
#define IME_CMODE_FULLSHAPE             0x0008
#define IME_CMODE_ROMAN                 0x0010
#define IME_CMODE_CHARCODE              0x0020
#define IME_CMODE_HANJACONVERT          0x0040
#define IME_CMODE_SOFTKBD               0x0080
#define IME_CMODE_NOCONVERSION          0x0100
#define IME_CMODE_EUDC                  0x0200
#define IME_CMODE_SYMBOL                0x0400
#define IME_CMODE_FIXED                 0x0800

#define IME_SMODE_NONE                  0x0000
#define IME_SMODE_PLAURALCLAUSE         0x0001
#define IME_SMODE_SINGLECONVERT         0x0002
#define IME_SMODE_AUTOMATIC             0x0004
#define IME_SMODE_PHRASEPREDICT         0x0008
#define IME_SMODE_CONVERSATION          0x0010

#define ISC_SHOWUICANDIDATEWINDOW       0x00000001
#define ISC_SHOWUICOMPOSITIONWINDOW     0x80000000
#define ISC_SHOWUIGUIDELINE             0x40000000
#define ISC_SHOWUIALLCANDIDATEWINDOW    0x0000000F
#define ISC_SHOWUIALL                   0xC000000F

#define GCS_COMPREADSTR                 0x0001
#define GCS_COMPREADATTR                0x0002
#define GCS_COMPREADCLAUSE              0x0004
#define GCS_COMPSTR                     0x0008
#define GCS_COMPATTR                    0x0010
#define GCS_COMPCLAUSE                  0x0020
#define GCS_CURSORPOS                   0x0080
#define GCS_DELTASTART                  0x0100
#define GCS_RESULTREADSTR               0x0200
#define GCS_RESULTREADCLAUSE            0x0400
#define GCS_RESULTSTR                   0x0800
#define GCS_RESULTCLAUSE                0x1000

#define IMN_CLOSESTATUSWINDOW           0x0001
#define IMN_OPENSTATUSWINDOW            0x0002
#define IMN_CHANGECANDIDATE             0x0003
#define IMN_CLOSECANDIDATE              0x0004
#define IMN_OPENCANDIDATE               0x0005
#define IMN_SETCONVERSIONMODE           0x0006
#define IMN_SETSENTENCEMODE             0x0007
#define IMN_SETOPENSTATUS               0x0008
#define IMN_SETCANDIDATEPOS             0x0009
#define IMN_SETCOMPOSITIONFONT          0x000A
#define IMN_SETCOMPOSITIONWINDOW        0x000B
#define IMN_SETSTATUSWINDOWPOS          0x000C
#define IMN_GUIDELINE                   0x000D
#define IMN_PRIVATE                     0x000E

#endif
