/***************************************************************************

  M.A.M.E.32  -  Multiple Arcade Machine Emulator for Win32
  Win32 Portions Copyright (C) 1997-2001 Michael Soderstrom and Chris Kirmse

  This file is part of MAME32, and may only be used, modified and
  distributed under the terms of the MAME license, in "readme.txt".
  By continuing to use, modify or distribute this file you indicate
  that you have read the license and understand and accept it fully.

 ***************************************************************************/

/*********************************************************************

  Win32text.c

  Functions used to retrieve text used by Windows GUI, to aid in
  translation.

  Created by RYO.

*********************************************************************/

#include "driver.h"
#include "win32text.h"

#ifdef BUILD_ENGLISH
static const char *default_text[] =
{
	/* icon explanation */
    "Toggle Folder List",
    "Toggle Screen Shot",
    "Large Icons",
    "Small Icons",
    "List",
    "Details",
//	"Japanese Game List",
	"'The' position move",
#ifdef KAILLERA
//	"Use IME",
	"Use Fixed Form",
#endif
    "About",
	"Invalid Button Index",

	/* old control warning */
	"NMAME X II has detected an old version of comctl32.dll\n\n",
	"Game Properties, many configuration options and\n",
	"features are not available without an updated DLL\n\n",
	"Please install the common control update found at:\n",
	"\n",
	"http://www.microsoft.com/msdownload/ieplatform/ie/comctrlx86.asp\n\n",
	"Would you like to continue without using the new features?\n",
	"NMAME X II - Outdated comctl32.dll Warning",

	/* list view column */
    "Game",
    "Folder",
    "Trackball",
    "Played",
    "Manufacturer",
    "Year",
	"Genre",
    "Clone Of",

	/* game genre */
	"Action",
	"Shoot'em up",
	"Fighting",
	"Drive",
	"Sport",
	"Puzzle",
	"Table",
	"Quiz",

	/* progress bar */
	"MMX",
	"XXXX games",
	"Imperfect Colors",
	"Game search",
	"complete",

	/* status bar */
	"Ready",
	"games",

	/* menu bar */
	"&Play",
	"&Play %s",

	/* command line */
	"NMAME X II does not support the game '%s'",
	"NMAME X II - game not support",
	"Error parsing screen size: %dx%d not supported",
	"NMAME X II - resolution not support",
	"Unknown option \'%s\', continue anyway?",
	"NMAME X II - Unknown Option",

	/* about NMAME X II */
	"\r\n",
	"NMAME X II  Ver.13\r\n",
	"Copyright(C) 2000-2001\r\n",
	"\r\n",
	"Produced by RYO (nmamex@go.to)\r\n",
	"\r\n",
	"\"NMAME X Project\"\r\n",
	"http://go.to/nmamex/\r\n",
	"\r\n",
	"- Special Thanks -\r\n",
	"NJ\r\n",
	"kurohane\r\n",
	"karutie\r\n",
	"yi-ping\r\n",
	"Haou\r\n",
	"tano\r\n",
	"King Kr00za\r\n",
	"<sound.dat producer>\r\n",
	"Izumi.\r\n",
	"Dies.M\r\n",
	"kpull\r\n",
	"DINO135\r\n",
	"O\r\n",
	"ALB.\r\n",
	"DO2\r\n",
	"kurohane\r\n",
	"<cheat.dat producer>\r\n",
	"yoi\r\n",
	"<command.dat producer>\r\n",
	"yoi\r\n",
	"wham\r\n",
	"RYO\r\n",
	"MILK-t\r\n",
	"<history.dat producer>\r\n",
	"AGDB-Japan(original data)\r\n",
	"MAME E2J(original data)\r\n",
	"Magma\r\n",
	"\r\n",
	"= Based =\r\n",
	"\r\n",
	"[NMAME & NMAME32]\r\n",
	"NJ\r\n",
	"saka\r\n",
	"\r\n",
	"= Original =\r\n",
	"\r\n",
	"[MAME (Multiple Arcade Machine Emulator)]\r\n",
	"Nicola Salmoria\r\n",
	"the MAME team\r\n",
	"\r\n",
	"[MAME32]\r\n",
	"Michael Soderstrom\r\n",
	"Christopher Kirmse\r\n",
	"the MAME32 team\r\n",

	/* DirectX help */
	"NMAME X II requires DirectX version 7 or later, which is a set of operating\r\n",
	"system extensions by Microsoft for Windows 95 and Windows 2000.\r\n\r\n",
	"Visit Microsoft's DirectX web page at http://www.microsoft.com/directx\r\n",
	"download DirectX, install it, and then run NMAME X II again.\r\n",

	/* NMAME X II help */
	"M.A.M.E. - Multiple Arcade Machine Emulator",
	"Copyright (C) 1997-2001  by Nicola Salmoria and the MAME team.",
	"MAME32 - Multiple Arcade Machine Emulator for Win32",
	"by Michael Soderstrom and Christopher Kirmse.",
	"NMAME X II - NeoGeo only version of MAME32",
	"by RYO (http://go.to/nmamex/)",
	"Usage:",
	"NMAMEX2 [game] [options]",

	/* recording relation */
	"Could not open '%s' as a valid input file.",
	"NMAME X II - valid input file",
	"MAME input files (*.inp,*.zip)\0*.inp;*.zip\0All files (*.*)\0*.*\0",
	"MAME input files (*.inp)\0*.inp;\0All files (*.*)\0*.*\0",
	"AVI files (*.avi)\0*.avi\0All files (*.*)\0*.*\0",

	/* loading roms */
	"Loading",

	/* rom list */
	"bytes",

	/* DirectX error code */
	"failed.\nerror code:",
	"DirectDraw not initialized.",
	"DirectInput not initialized.",

	/* Avi.c */
	"Reflected FPS in playing?",
	"Play back AVI speed",

	/* ColumnEdit.c */
	"Cannot Move Selected Item",
	"Move Item",
	"Selecting this Item is not permitted",
	"Select Item",

	/* DDrawDisplay.c */
	"DirectDraw does not support the requested mode %dx%d (16 bpp)",
	"NMAME X II does not work on 8-bit color.",
	"IDirectDrawSurface7.Restore failed.\nerror code(Primary):%s\nerror code(Back):%s\nerror code(Flip):%s",

	/* DirectDraw.c */
	"ddraw.dll not found.",
	"DirectDrawCreateEx not found.",

	/* DirectInput.c */
	"dinput.dll not found.",
	"DirectInputCreateEx not found.",

	/* DirectSound.c */
	"dsound.dll not found.",
	"DirectSoundCreate not found.",

	/* Directories.c */
	"ROMs",
	"Config",
	"Snapshots",
	"Icons",
	"Input files (*.inp)",
	"State",
	"Memory Card",
	"Flyers",
	"Cabinets",
	"Marquees",
	"NVRAM",
	"Combo",
	"Wave",
	"Folder does not exist, continue anyway?",
	"NMAME X II",
	"Folder name:",

	/* M32Util.c */
	"The operating system is out of memory or resources.",
	"The specified file was not found.",
	"There is no application associated with the given filename extension.",
	"There was not enough memory to complete the operation.",
	"The specified path was not found.",
	"A sharing violation occurred.",
	"Unknown error.",

	/* Properties.c */
	"Default Game",
	"Property Sheet Error",
	"Error",
	"(sound)",
	"%d colors (16-bit required)",
	"ROMs missing",
	"Not working",
	"Colors are wrong",
	"Imperfect Colors",
	"Working",
	"Unknown",
	"Global game options\nDefault options used by all games",
	"Auto size",
	"No Sound",
	"MIDAS",
	"DirectSound",
	"Primary Display",
	"x1",
	"x2 (slow)",
	"x2 (use blit / fast)",
	"x2 (use blit / fastest)",
	"x3 (use blit)",
	"x4 (use blit)",
	"Scan Lines",
	"Scan Lines (use blit)",
	"Stretch (use blit)",
	"Auto frame skip",
	"Draw every frame",
	"Skip %d of every 12 frames",
	"None",
	"HotRod",
	"HotRod SE",
	"ASM core",
	"C core",
	"Neo-Geo standard driver",
	"Neo-Geo raster driver",
	"standard BIOS",
	"debug BIOS",

	/* TreeView.c */
	"All Games",
	"Available",
#if defined(LMR)
	"UnAvailable",
#endif
	"Manufacturer",
	"Year",
	"Genre",
	"Working",
	"Non-Working",
	"Custom",
	"Played",
	"Favorites",
	"Originals",
	"Clones",
	"Trackball",
	"NMAME X II will now reset the selected items to\n",
	"the original, installation settings then exit.\n\n",
	"The new settings will take effect\n",
	"the next time NMAME X II is run.\n\n",
	"Do you wish to continue?",
	"NMAME X II - Restore Settings",

	/* audit32.c */
	"Checking Game",
	"File Audit",
	"Pause",
	"Continue",
	"Audit complete.\n",
	"Close",
	"None required",
	"Passed",
	"Best available",
	"Not found",
	"Failed",

	/* file.c */
	"Error writing %s to cfg.zip file",
	"Error writing %s to nv.zip file",

	/* mzip.c */
	"Error loading zip32.dll\n\n",
	"Zipped .cfg, .nv and .hi files\n",
	"can not be used without it\n\n",
	"Please reinstall the DLL from\n",
	"the NMAME X II distribution\n\n",
	"Would you like to continue\n",
	"without using the zip files?\n",
	"NMAME X II - zip32.dll not found",

	/* options.c */
	"NMAME X II has detected outdated configuration data.\n\n",
	"The detected configuration data is from Version %s of NMAME X II.\n",
	"The current version is %s. It is recommended that the\n",
	"configuration is set to the new defaults.\n\n",
	"Would you like to use the new configuration?",
	"Version Mismatch",

	NULL
};
#else
static const char *default_text[] =
{
	/* icon explanation */
    "tH_Xg̕\/\؂ւ",
    "XN[Vbg̕\/\؂ւ",
    "傫ACRŕ\",
    "ACRŕ\",
    "ꗗŕ\",
    "ڍׂŕ\",
	"Xg{\",
	"'The'Ōɂ",
#ifdef KAILLERA
	"`bgIMEgp",
	"`bgŒ^gp",
#endif
    "̃\tgɂ",
	"ȃ{^CfbNX",

	/* old control warning */
	"NMAME X II ͌Âo[Wcomctl32.dllo܂B\n\n",
	"DLLXVȂƁAIvV@\ݒ肷Q[̃vpeB\n",
	"\܂B\n\n",
	"ȉURLRRg[̃Abvf[g_E[h\n",
	"CXg[ĂB\n\n",
	"http://www.microsoft.com/msdownload/ieplatform/ie/comctrlx86.asp\n\n",
	"̂܂ܑ܂H\n",
	"NMAME X II - comctl32.dllXVĂ",

	/* list view column */
    "Q[",
    "tH_",
    "gbN{[",
    "vC",
    "[J[",
    "N",
	"W",
    "IWi",

	/* game genre */
	"ANV",
	"V[eBO",
	"iANV",
	"[VO",
	"X|[c",
	"pY",
	"e[uQ[",
	"NCY",
	"Action",
	"Shoot'em up",
	"Fighting",
	"Drive",
	"Sport",
	"Puzzle",
	"Table",
	"Quiz",

	/* progress bar */
	"MMX",
	"XXXX Q[",
	"Fł͂܂",
	"Q[̌",
	"",

	/* status bar */
	"N",
	"Q[",

	/* menu bar */
	"vC(&P)",
	"%s vC(&P)",

	/* command line */
	"NMAME X II  '%s' ƂQ[ɑΉĂ܂B",
	"NMAME X II - Ή̃Q[",
	"%dx%d ̉𑜓xɂ͑ΉĂ܂B",
	"NMAME X II - Ή̉ʉ𑜓x",
	"'%s' ͕sȃIvVłB܂H",
	"NMAME X II - sȃIvV",

	/* about NMAME X II */
	"\r\n",
	"NMAME X II  Ver.13\r\n",
	"Copyright(C) 2000-2001\r\n",
	"\r\n",
	"Produced by RYO (nmamex@go.to)\r\n",
	"\r\n",
	"\"NMAME X Project\"\r\n",
	"http://go.to/nmamex/\r\n",
	"\r\n",
	"- Special Thanks -\r\n",
	"NJ\r\n",
	"H\r\n",
	"邿\r\n",
	"yi-ping\r\n",
	"Haou\r\n",
	"̂\r\n",
	"King Kr00za\r\n",
	"<sound.dat >\r\n",
	"Izumi.\r\n",
	"Dies.M\r\n",
	"kpull\r\n",
	"DINO135\r\n",
	"O\r\n",
	"ALB.\r\n",
	"DO2\r\n",
	"H\r\n",
	"<cheat.dat >\r\n",
	"悢\r\n",
	"<command.dat >\r\n",
	"悢\r\n",
	"wham\r\n",
	"RYO\r\n",
	"MILK-t\r\n",
	"<history.dat >\r\n",
	"AGDB-Japan(f[^)\r\n",
	"MAME E2J(f[^)\r\n",
	"܂܂\r\n",
	"\r\n",
	"= Based =\r\n",
	"\r\n",
	"[NMAME & NMAME32]\r\n",
	"NJ\r\n",
	"₳\r\n",
	"\r\n",
	"= Original =\r\n",
	"\r\n",
	"[MAME (Multiple Arcade Machine Emulator)]\r\n",
	"Nicola Salmoria\r\n",
	"the MAME team\r\n",
	"\r\n",
	"[MAME32]\r\n",
	"Michael Soderstrom\r\n",
	"Christopher Kirmse\r\n",
	"the MAME32 team\r\n",

	/* DirectX help */
	"NMAME X II ́AWindows 95/98/NT/2000OSgZbgłDirectX\r\n",
	"o[W7.0ȍ~KvłB\r\n\r\n",
	"MicrosoftDirectXz[y[W(http://www.microsoft.com/japan/directx)\r\n",
	"DirectX_E[hACXg[ NMAME X II NĂB\r\n",

	/* NMAME X II help */
	"M.A.M.E. - Multiple Arcade Machine Emulator",
	"Copyright (C) 1997-2001  by Nicola Salmoria and the MAME team.",
	"MAME32 - Multiple Arcade Machine Emulator for Win32",
	"by Michael Soderstrom and Christopher Kirmse.",
	"NMAME X II - NeoGeo only version of MAME32",
	"by RYO (http://go.to/nmamex/)",
	"gp@:",
	"NMAMEX2 [Q[] [IvV]",

	/* recording relation */
	"'%s' ͕sinpt@Ĉ߁AI[vł܂B",
	"NMAME X II - sinpt@C",
	"MAME inputt@C(*.inp,*.zip)\0*.inp;*.zip\0SẴt@C(*.*)\0*.*\0",
	"MAME inputt@C(*.inp)\0*.inp;\0SẴt@C(*.*)\0*.*\0",
	"AVIt@C(*.avi)\0*.avi\0SẴt@C(*.*)\0*.*\0",

	/* loading roms */
	"[h",

	/* rom list */
	"oCg",

	/* DirectX error code */
	"ŃG[܂\nG[R[h:",
	"DirectDrawĂ܂B",
	"DirectInputĂ܂B",

	/* Avi.c */
	"vCFPS𔽉f܂H",
	"L^AVI̍ĐXs[h",

	/* ColumnEdit.c */
	"̍ڂ͈ړł܂B",
	"NMAME X II - ڂ̈ړ",
	"̍ڂ̑I͋Ă܂B",
	"NMAME X II - ڂ̑I",

	/* DDrawDisplay.c */
	"DirectDraw %dx%d (16 bpp) [hT|[gĂ܂B",
	"NMAME X II 8bitJ[ł͓삵܂B",
	"IDirectDrawSurface7.Restore ŃG[܂\nG[R[h(Primary):%s\nG[R[h(Back):%s\nG[R[h(Flip):%s",

	/* DirectDraw.c */
	"ddraw.dll ܂B",
	"DirectDrawCreateEx ܂B",

	/* DirectInput.c */
	"dinput.dll ܂B",
	"DirectInputCreateEx ܂B",

	/* DirectSound.c */
	"dsound.dll ܂B",
	"DirectSoundCreate ܂B",

	/* Directories.c */
	"ROMC[W",
	"ݒt@C",
	"XibvVbg",
	"ACR",
	"̓f[^t@C",
	"Q[ԕۑf[^",
	"J[h",
	"L摜",
	"Lrlbg摜",
	"}[L[摜",
	"NVRAMf[^",
	"R{f[^",
	"",
	"tH_܂B܂H",
	"NMAME X II - tH_܂",
	"tH_:",

	/* M32Util.c */
	"̓\[XsĂ܂B",
	"w肳ꂽt@C܂B",
	"gqɊ֘AtꂽAvP[V܂B",
	"𑱍s邽߂̃s܂B",
	"w肳ꂽpX܂B",
	"Lᔽ܂B",
	"s̃G[܂B",

	/* Properties.c */
	"W̃Q[ݒ",
	"vpeBV[g̃G[",
	"NMAME X II - vpeBV[g̃G[",
	"(TEh)",
	"%d F (v 16bitJ[)",
	"ROM܂",
	"삵ȂQ[ł",
	"Fł͂܂",
	"F̍ČsSł",
	"",
	"s",
	"O[oIvV\nSẴQ[ŎgpW̐ݒ",
	"",
	"TEhȂ",
	"MIDAS",
	"DirectSound",
	"vC}fBXvC",
	"gȂ",
	"x2 (ᑬ)",
	"x2 (blitgp/⍂)",
	"x2 (blitgp/)",
	"x3 (blitgp)",
	"x4 (blitgp)",
	"XLC",
	"XLC (blitgp)",
	"ʑŜɕ\ (blitgp)",
	"XLbv",
	"St[`",
	"%d/12t[XLbv",
	"W",
	"HotRod",
	"HotRod SE",
	"ASM RA",
	"C RA",
	"WhCo",
	"X^ʑΉhCo",
	"COBIOS",
	"fobOBIOS",

	/* TreeView.c */
	"SQ[",
	"LQ[",
#if defined(LMR)
	"LQ[",
#endif
	"[J[",
	"N",
	"W",
	"",
	"ُ",
	"JX^",
	"vCQ[",
	"Cɓ",
	"IWi",
	"N[",
	"gbN{[",
	"NMAME X II ͑IꂽڂCXg[\n",
	"̐ݒɖ߂āAI܂B\n",
	"Vݒ́A̋Nɔf܂B\n",
	"\n",
	"܂H",
	"NMAME X II - ݒ̏",

	/* audit32.c */
	"`FbN Q[",
	"t@Č",
	"ꎞ~",
	"ĊJ",
	"`FbNI\n",
	"",
	"Kv܂",
	"ł",
	"zosǂROM܂AROMsȂߌŖ肠܂",
	"܂",
	"ُł",

	/* file.c */
	"%scfg.zipt@Cɏo܂",
	"%snv.zipt@Cɏo܂",

	/* mzip.c */
	"zip32.dllǂݍݒɃG[܂B\n\n",
	"zipk .cfg, .nv .hi t@ĆÃt@\n",
	"CȂƎgpł܂B\n\n",
	"DLL NMAME X II ̔zzt@CăCXg[\n",
	"ĂB\n",
	"\n",
	"zipt@CgpȂő܂H\n",
	"NMAME X II - zip32.dll܂",

	/* options.c */
	"NMAME X II ́AÂݒo܂B\n\n",
	"óANMAME X II o[W %s ̂̂łB\n",
	"݂̃o[W %s łB\n",
	"݂̃o[WɂVftHgݒgp邱Ƃ𐄏܂B\n\n",
	"Vݒgp܂H",
	"NMAME X II - o[W̑",

	NULL
};
#endif

const char *win32_getstring(int string_num)
{
	return default_text[string_num];
}

void connect_strings(char *buf, int string_num_start, int string_num_end)
{
	int i;

	if (string_num_start >= string_num_end)
		return;

	strcpy(buf, default_text[string_num_start]);

	for (i = string_num_start + 1 ; i <= string_num_end ; i++)
		strcat(buf, default_text[i]);

	return;
}

