#ifndef MEM_MANAGER_H
#define MEM_MANAGER_H

#ifdef MEM_DEBUG

void memory_manager_init(void);
void *my_malloc(size_t size, char *file, int line);
void *my_calloc(size_t n, size_t size, char *file, int line);
void *my_realloc(void *ptr, size_t size, char *file, int line);
void my_free(void *ptr);

#define MyMalloc(size)       my_malloc((size), __FILE__, __LINE__)
#define MyCalloc(n, size)    my_calloc((n), (size), __FILE__, __LINE__)
#define MyRealloc(ptr, size) my_realloc((ptr), (size), __FILE__, __LINE__)
#define MyFree(ptr)          my_free((ptr))

#else

#define memory_manager_init()

#define MyMalloc(size)       malloc((size))
#define MyCalloc(n, size)    calloc((n), (size))
#define MyRealloc(ptr, size) realloc((ptr), (size))
#define MyFree(ptr)          free((ptr))

#endif

#endif
