/*********************************************************************

  usrintrf.h

  Functions used to handle MAME's crude user interface.

*********************************************************************/

#ifndef USRINTRF_H
#define USRINTRF_H

struct DisplayText
{
	const char *text;	/* 0 marks the end of the array */
	int color;	/* see #defines below */
	int x;
	int y;
};

#define UI_COLOR_NORMAL 0	/* white on black text */
#define UI_COLOR_INVERSE 1	/* black on white text */

#define FONT_COLOR_NORMAL			Machine->system_color[0]
#define BUTTON_COLOR_RED			Machine->system_color[1]
#define BUTTON_COLOR_YELLOW			Machine->system_color[2]
#define BUTTON_COLOR_GREEN			Machine->system_color[3]
#define BUTTON_COLOR_BLUE			Machine->system_color[4]
#define VOLUME_DARKRED				Machine->system_color[5]
#define VOLUME_DARKYELLOW			Machine->system_color[6]
#define VOLUME_DARKGREEN			Machine->system_color[7]
#define SYSTEM_COLOR_FRAMEMIDIUM	Machine->system_color[8]
#define SYSTEM_COLOR_FRAMELIGHT		Machine->system_color[9]
#define SYSTEM_COLOR_FRAMEDARK		Machine->system_color[10]
#define CURSOR_COLOR				Machine->system_color[11]
#define COLOR_MAX_NUMBER	12

#define SEL_BITS 12		/* main menu selection mask */
#define SEL_BITS2 4		/* submenu selection masks */
#define SEL_MASK ((1<<SEL_BITS)-1)
#define SEL_MASK2 ((1<<SEL_BITS2)-1)

#define MAX_SCROLLBUF  65536
#define SCR_PAGE_MASK  0xffffff
#define SCR_NEXT_PAGE  0x1000000
#define SCR_PREV_PAGE  0x10000000

void displaytext(struct osd_bitmap *bitmap, const struct DisplayText *dt, int fonttype);
void ui_text(struct osd_bitmap *bitmap,const char *buf,int x,int y);
void ui_drawbox(struct osd_bitmap *bitmap,int leftx,int topy,int width,int height,int trans);
int ui_displaymessagewindow(struct osd_bitmap *bitmap,const char *text);
void ui_displaymenu(struct osd_bitmap *bitmap,const char **items,const char **subitems,char *flag,int selected,int arrowize_subitem);
int showcopyright(struct osd_bitmap *bitmap);
int showgamewarnings(struct osd_bitmap *bitmap);
void set_ui_visarea (int xmin, int ymin, int xmax, int ymax);

void init_user_interface(void);
int handle_user_interface(struct osd_bitmap *bitmap);

int onscrd_active(void);
int setup_active(void);

void CLIB_DECL usrintf_showmessage(const char *text,...);
void CLIB_DECL usrintf_showmessage_secs(int seconds, const char *text,...);

#endif
